' Spiral PollyGone V2.9
' Parabolic and curve spiral and polygon generator with mesh 
' For CamBam Plus 
' (c) Evan Williams 2009
' 
' You may copy and distribute this program freely. Do not remove this notice.


sub main

rem ---------------User input Declarations -------------------

	dim depth as double = 0 :	' depth of parabolic function, sagitta
	dim steps as double = 3	' number of line segments per rotation
	dim inradius as double = 0		' inside starting radius
	dim outradius as double = 1		' outside radius maximum
	dim turns as double = 1		' number of wraps in spiral
	dim startangle as double =0 	' starting angle
	dim curve as integer = 1  	' parabolic/curve slope
	dim invert as integer = 1		' invert z flag
	dim xyScale as double	 =1		' custom scale factor
	dim xyScale2 as double = 1	' custom scale factor 2
  	dim poly as integer=0
  	dim zscale2 as double = 1	' custom scale factor 2
	dim mesh as integer=0

rem -----------------Declarations----------------------------

	dim inputValue as string
	dim slope as double = 1		' slope for curve function
	dim oneturn as double = 0	' scaled x,y value per rotation
	dim zscale as double = 0		' scaled z value per rotation
	dim radius as double = 0	' temp value of radius
	dim x as double = 0		' polyline coordinate
	dim y as double = 0		' polyline coordinate
	dim oldx as double = 0		' polyline coordinate
	dim oldy as double = 0		' polyline coordinate
	dim z as double = 0		' polyline coordinate
	dim oldz as double = 0		' polyline coordinate
	dim oldzscale as double=0
	dim zinc as double=0
	dim angle as double = 0		' polar coordinate for trig function
	dim AngleInc as double = 0		' radial fraction per step in radians
	dim parabolic as double =0		' parabolic function
	dim I as double			' loop counters
	dim j as double
	dim inc as integer=0
	dim iparabolic	as double=0
	dim dline as string = chr(10)+chr(10)
	dim oldrad as double = 0
	dim oldangle as double =0

	rem --------------------Input parameters------------------------
	
	inputValue=inputbox("Enter starting angle in degrees, zero=north" +dline+"Click Cancel to exit this process", _
	"Start Angle of Spiral or Polygon","0")
	if inputValue ="" then exit sub
	startangle=cdbl(inputValue)*(pi/180)+(pi/2)		' convert to radians
	angle=startangle: oldangle=angle

	inputValue=inputbox("Enter number of revolutions", "Revolutions","64")
	if inputValue="" then exit sub
	turns=cdbl(inputValue)

	inputValue=inputbox("Enter number of steps/sides per revolution." _
	 +dline+" Hint: 4 make a square, 6 make a hexagon, 360 make a circle", "Steps", "64")
	if inputValue="" then exit sub	
	rem if inputValue <= "2" then inputValue ="3"
	steps= cdbl(inputValue)

	inputValue=inputbox("Enter Inside Diameter in units", "Inside Diameter","0")
	if inputValue="" then exit sub	
	inradius=cdbl(inputValue)/2 					' convert to radial

  	inputValue=InputBox("Enter Outside Diameter limit (circumcircle) in units." _
	+" If same as inside diameter then it creates a regular polygon", "Outside Diameter","50")
	if inputValue="" then exit sub
	outradius=cdbl(inputValue)/2				' convert to radial
	if outradius < inradius then outradius=inradius
	
	inputValue=InputBox("Enter Z Depth in units, zero creates 2D polygon or spiral", "Depth","10")
	if inputValue = "" then exit sub
	depth = cdbl(inputValue)

	if depth >0 then inputValue = InputBox("Enter custom X,Y scale factor or click OK for default", "Scale","1")
	if inputValue = "" then exit sub
	if depth>0 then xyScale = cdbl(inputValue)

  	if depth >0 then inputValue = InputBox("Enter z exponential scale factor or click OK for default", "Scale","1")
	if inputValue = "" then exit sub
	if depth>0 then zscale2 = cdbl(inputValue)

	if depth >0 then inputValue = inputbox("Select radial function by number"+dline+"1: linear"+dline+ _
	"2: Parabolic"+dline+"3: Inverse parabolic","Radial Function","3") :if inputValue = "" or inputValue = "0" then exit sub
  	if depth >0 then	curve = math.abs(cuint(inputValue)): if curve>3 then curve = 1

	inputValue = msgbox("Clear Active Layer?", 36,"Clear Layer")
	If inputValue = "6" then doc.ActiveLayer.Entities.Clear()	' clear active layer
	
	if depth<>0 then inputValue = msgbox("Invert Z?", 36,"Invert Z") : If inputValue = "6" then invert = 1 else invert = -1

	inputValue = msgbox("Make mesh?", 36,"Polygon mesh") : If inputValue = "6" then poly = 1 else poly = 0

rem ----------------- do something! ------------------------------

	oneturn = ((outradius-inradius)/turns)/xyScale		' derive radius increment per turn
	AngleInc = (2*pi)/steps	 					' polar increment polyline coordinate
	dim p as Polyline = new Polyline
	radius = inradius: oldrad = inradius
	parabolic = depth-(radius*radius)* (depth/(outradius*outradius))
	iparabolic = depth-((outradius-radius)*(outradius-radius))* (depth/((outradius-inradius)*(outradius-inradius)))

	slope = depth/(turns*steps)
	if curve = 1 then zscale = depth 			' linear function
	if curve = 2 then zscale = parabolic				' parabolic 
	if curve = 3 then zscale = iparabolic 			' inverse parabolic
	if curve = 4 then zscale = ((iparabolic*parabolic-1)/2) 	' parbolic multiplied by inverse parabolic
	
	z = zscale
	oldz = zscale:		inc = 0
	if poly = 1 then goto polydo


rem ----------------------Main Loop for spiral no mesh-----------------------------

	for i = 0 to turns-1 	' step through the turns
		radius = inradius+i*oneturn 					' next turn starting radius
    
		for j = 1 to steps 
			inc = inc+xyScale2 : 'if inc > turns*steps then inc = 1	:xyScale2 not implemented = 1
			x = radius * math.cos(angle)	' calculate cartesian coordinates
			y = radius * math.sin(angle)	' scaled by radius
 			rem z = (z/(zscale2^zscale2))*zscale2
			z = zscale
			
			radius = radius + oneturn/steps	' next polar distance vector
			parabolic = depth-(radius*radius)*(depth/(outradius*outradius))
			iparabolic = depth- ((outradius-radius)*(outradius-radius)) * (depth/((outradius-inradius)*(outradius-inradius)))
      
			if curve = 2 then zscale = parabolic
			if curve = 3 then zscale = iparabolic
			
			if curve = 4 then zscale = (((iparabolic*parabolic)/2)-.50001) 
			if curve = 1 then zscale = (depth/turns*inc)
			'if math.abs( zscale) > depth then zscale = zscale mod depth :
			
			angle = angle + AngleInc		 		' increment polar coordinate
			p.Add(x,y,z) 				' add coordinates to polyline list

			If poly = 1 then
			p.Add(oldx,oldy,oldz*invert) 				' add coordinates to polyline list
			p.Add(x,y,z) 
			end if



		next j
		rem inputValue = msgbox("zscale equals"+str(zscale), 0,"debug")
	

	next i

rem ---------------------one last step to avoid a fencepost error-------------

	x = radius * math.cos(angle)		
	y = radius * math.sin(angle)		
	z = zscale

    z = (z/(zscale2^zscale2))*zscale2
	p.Add(x,y,z) 

	doc.Add(p)  ' Print it!
	if poly < 1 then goto Done

'####################### MESH ######################################

Polydo:

	for i = 0 to turns 	' step through the turns
	
		oldz = zscale: 
  		inc = inc+1 : 'if inc > turns*steps then inc = 1	   		

		parabolic = depth-(radius*radius)*(depth/(outradius*outradius))
		iparabolic = depth-((outradius-radius)*(outradius-radius))*(depth/((outradius-inradius)*(outradius-inradius)))
        
		if curve = 2 then zscale = parabolic
		if curve = 3 then zscale = iparabolic
			
		if curve = 4 then zscale = (((iparabolic*parabolic)/2)-.50001) 
		if curve = 1 then zscale = depth-(i*(depth/(turns)))
		z = zscale
		
		z = (z/(zscale2^zscale2))*zscale2
 		x = radius * math.cos(angle)	'calculate cartesian coordinates
		y = radius * math.sin(angle)	'scaled by radius																
		p.Add(x,y,z*invert) 
'------------------------------
			for j = 0 to steps 
				'angle = angle + AngleInc	'CHANGE old	 
				x = radius * math.cos(angle)	'calculate cartesian coordinates
				y = radius * math.sin(angle)	'scaled by radius																
				p.Add(x,y,z*invert) 
				inc = inc+xyScale2 : if inc > turns*steps then inc = 1	
				angle = angle + AngleInc	
			next j
		angle = oldangle
		'p.Add(x,y,z*invert) 
'---------------------------------
			for j = 1 to steps ' add triangles
				angle = angle + AngleInc	
	 			x = radius * math.cos(angle)	' calculate cartesian coordinates
				y = radius * math.sin(angle)	' scaled by radius
				oldrad = radius-oneturn:if oldrad<inradius then oldrad = inradius
				oldx = (oldrad) * math.cos(angle)	' calculate cartesian coordinates
				oldy = (oldrad) * math.sin(angle)	' scaled by radius											
				'p.Add(x,y,z*invert) 					
				if oldz <> z then p.Add(oldx,oldy,oldz*invert) 
				p.Add(x,y,z*invert) 	
	
			next j
		'p.Add(oldx,oldy,oldz*invert) 
		p.Add(x,y,z*invert) 	
		radius = radius+oneturn			' next turn radius
		angle = oldangle
		next i


	doc.Add(p) ' Print it!
Done:
end sub
