' Spiral PollyGone V2.4
' Parabolic, linear spiral and polygon generator
' For CamBam Plus 
' (c) Evan Williams 2008
' 
' You may modify, copy and distribute this program freely. You may not remove this notice.


sub main

rem ---------------User input Declarations -------------------

	dim depth as single = 0 :	' depth of parabolic function, sagitta
	dim steps as single = 360	' number of line segments per rotation
	dim irad as single = 0		' inside starting radius
	dim orad as single = 1		' outside radius maximum
	dim turns as single = 0		' number of wraps in spiral
	dim startangle as single =0  	' starting angle
	dim linear as integer = 1   	' parabolic/linear slope
	dim invert as integer = 1		' invert z flag
	dim cscale as single	 =1		' custom scale factor
	dim cscale2 as single = 1	' custom scale factor 2
rem -----------------Declarations----------------------------

	dim inval as string
	dim slope as single = 1		' slope for linear function
	dim oneturn as double = 0	' scaled x,y value per rotation
	dim zscale as single = 0		' scaled z value per rotation
	dim radius as double = 0	' temp value of radius
	dim x as single = 0		' polyline coordinate
	dim y as single = 0		' polyline coordinate
	dim z as single = 0		' polyline coordinate
	dim xy as double = 0		' polar coordinate for trig function
	dim rf as double = 0		' radial fraction per step in radians
	dim para as single =0		' parabolic function
	dim I as integer			' loop counters
	dim j as integer
	dim inc as integer
	dim ipara	as single
	dim dline as string = chr(10)+chr(10)

rem --------------------Input parameters------------------------
	
	inval=inputbox("Enter starting angle in degrees, zero=north" +dline+"Click Cancel to exit this process", _
	"Start Angle of Spiral or Polygon","0")
	if inval ="" then exit sub
	startangle=csng(inval)*(pi/180)+(pi/2)		' convert to radians
	xy=startangle

	inval=inputbox("Enter number of revolutions", "Revolutions","64")
	if inval="" then exit sub
	turns=csng(inval)

	inval=inputbox("Enter number of steps/sides per revolution." _
	 +dline+" Hint: 4 make a square, 6 make a hexagon, 360 make a circle", "Steps", "64")
	if inval="" then exit sub	
	rem if inval <= "2" then inval ="3"
	steps= csng(inval)

	inval=inputbox("Enter Inside Diameter in units", "Inside Diameter","0")
	if inval="" then exit sub	
	irad=csng(inval)/2 					' convert to radial

   	inval=InputBox("Enter Outside Diameter limit (circumcircle) in units." _
	+" If same as inside diameter then it creates a regular polygon", "Outside Diameter","50")
	if inval="" then exit sub
	orad=csng(inval)/2				' convert to radial
	if orad < irad then orad=irad
	
	inval=InputBox("Enter Z Depth in units, zero creates 2D polygon or spiral", "Depth","4")
	if inval="" then exit sub
	depth=csng(inval)

	if depth >0 then inval=InputBox("Enter custom scale factor or click OK for default", "Scale","1")
	if inval="" then exit sub
	if depth>0 then cscale=csng(inval)

	if depth >0 then inval=inputbox("Select radial function by number"+dline+"1: linear"+dline+ _
	"2: Parabolic"+dline+"3: Inverse parabolic","Radial Function","3") :if inval="" or inval="0" then exit sub
   	if depth >0 then	linear=math.abs(cuint(inval)): if linear>3 then linear=1

	inval=msgbox("Clear Active Layer?", 36,"Clear Layer")
	If inval="6" then doc.ActiveLayer.Entities.Clear()	' clear active layer
	
	if depth<>0 then inval=msgbox("Invert Z?", 36,"Invert Z") : If inval="6" then invert = -1 else invert =1

rem ----------------- do something! ------------------------------

	oneturn=((orad-irad)/turns)/cscale		' derive radius increment per turn
	rf = (2*pi)/steps	  					' polar increment polyline coordinate
	dim p as Polyline = new Polyline
	radius=irad
	para= depth-(radius*radius)* (depth/(orad*orad))
	ipara= depth-((orad-radius)*(orad-radius))* (depth/((orad-irad)*(orad-irad)))

	slope=depth/(turns*steps)
	if linear= 1 then zscale = depth 				' linear function
	if linear= 2 then zscale = para					' parabolic 
	if linear= 3 then zscale = ipara 				' inverse parabolic
	if linear= 4 then zscale=((ipara*para-1)/2) 	' parbolic multiplied by inverse parabolic
	

	inc=0
rem ----------------------Main Loop -----------------------------

	for i = 0 to turns-1  	' step through the turns
		 radius=irad+i*oneturn 			' next turn starting radius
		for j = 1 to steps 
			inc=inc+cscale2 : if inc > turns*steps then inc = 1	
			x = radius * math.cos(xy)	' calculate cartesian coordinates
			y = radius * math.sin(xy)	' scaled by radius
			z = zscale*-1 * invert			' 
			radius=radius + oneturn/steps	' next polar distance vector
			para= depth-(radius*radius)*(depth/(orad*orad))
			ipara= depth- ((orad-radius)*(orad-radius)) * (depth/((orad-irad)*(orad-irad)))
			if linear=2 then zscale=para
			if linear = 3 then zscale = ipara
			
			if linear=4 then zscale=(((ipara*para)/2)-.50001) 
			if linear=1 then zscale= (depth-slope*inc)
			if math.abs( zscale) > depth then zscale = zscale mod depth :
			xy = xy + rf		 		' increment polar coordinate
			p.Add(x,y,z) 				' add coordinates to polyline list
		next j
		rem inval=msgbox("zscale equals"+str(zscale), 0,"debug")
	

	next i

rem ---------------------one last step to avoid a fencepost error-------------

	x = radius * math.cos(xy)		
	y = radius * math.sin(xy)		
	z = zscale*-1 * invert
	p.Add(x,y,z) 

	doc.Add(p)    ' Print it!
end sub
